 /*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO building block car lesson 2
 * tutorial: https://osoyoo.com/?p=49716
 * CopyRight www.osoyoo.com
 */
#include <PWMServo.h>
#define IN1 11 //IN1 to D12
#define IN2 12 //IN2 to D11
#define ENA 5  //  ENA pin to D5
#define LEFT_LIGHT 4 //  left light to D4
#define RIGHT_LIGHT 13 //  right light to D13

#define FRONT 90        // 90 degree means steering to front 
int RIGHT=FRONT+80;
int LEFT=FRONT-38;

#define DELAY_TIME 1200     
#define BACK_TIME 1000  
#define SPEED 190
#define HI_SPEED 220
#define SERVO_PIN 9  //servo connect to D9
                                                                                                       
PWMServo head;
/*motor control*/
void go_Back(int speed)  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW); 
  analogWrite(ENA,speed);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,LOW);
  digitalWrite(LEFT_LIGHT,LOW); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
  delay (200);
  digitalWrite(RIGHT_LIGHT,LOW);
  digitalWrite(LEFT_LIGHT,LOW); 
  delay (200);
}
 
void  go_Advance(int speed)  //Forward
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH); 
  analogWrite(ENA,speed);
  digitalWrite(RIGHT_LIGHT,LOW); 
  digitalWrite(LEFT_LIGHT,LOW); 
}
 
void turn(int angle)
{

  head.write(angle);
  if (angle<FRONT) {
    digitalWrite(RIGHT_LIGHT,LOW); 
    digitalWrite(LEFT_LIGHT,HIGH); 
  }
  if (angle>FRONT) {
    digitalWrite(RIGHT_LIGHT,HIGH); 
    digitalWrite(LEFT_LIGHT,LOW); 
  }
}
 
void stop_Stop()    //Stop
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,LOW);
  analogWrite(ENA,0);
  digitalWrite(RIGHT_LIGHT,HIGH);
  digitalWrite(LEFT_LIGHT,HIGH); 
}

  
void setup() {

 pinMode(ENA, OUTPUT); 
 pinMode(IN1, OUTPUT); 
 pinMode(IN2, OUTPUT); 
 pinMode(LEFT_LIGHT, OUTPUT); 
 pinMode(RIGHT_LIGHT, OUTPUT); 
 head.attach(SERVO_PIN);
 turn(FRONT);  // Steering to front
 go_Advance(SPEED);
 delay(DELAY_TIME); 
 
 go_Back(SPEED);
 delay(DELAY_TIME);

 go_Advance(HI_SPEED);
 turn(LEFT);
 delay(1000);
turn(FRONT);
 turn(RIGHT);
 delay(1000);
 turn(FRONT);
 stop_Stop();//stop move
 delay(500);
 turn(FRONT);
 go_Back(HI_SPEED);
 delay(BACK_TIME);
 turn(RIGHT);
 delay(BACK_TIME);
 turn(LEFT);
delay(BACK_TIME);
go_Advance(HI_SPEED);
 turn(LEFT);
 delay(500);
turn(FRONT);
 turn(RIGHT);
 delay(500);
 turn(FRONT);
 stop_Stop();//stop move
}

 
void loop() {
 
}
